#include <stdio.h>
#include <gdk-pixbuf/gdk-pixbuf.h>

#define SRC_IMAGE "image.ico"
#define FILE_TO_SAVE "result.ico"

#define X 49
#define Y 0

guint32 get_pixel(GdkPixbuf* pixbuf, int x, int y)
{
    guchar* pixels = gdk_pixbuf_get_pixels(pixbuf);
    return *((guint32*)(pixels +
                        gdk_pixbuf_get_n_channels(pixbuf) * x + 
                        gdk_pixbuf_get_rowstride(pixbuf) * y));
}
int main()
{
    g_type_init();
    
    GdkPixbuf* pixbuf = gdk_pixbuf_new_from_file(SRC_IMAGE, NULL);
    
    GdkPixbuf* result = gdk_pixbuf_scale_simple(pixbuf,
        gdk_pixbuf_get_width(pixbuf),
        gdk_pixbuf_get_height(pixbuf),
        GDK_INTERP_HYPER);
        
    printf("After 1:1 pixel mapping with 'interp_type' = GDK_INTERP_HYPER\n");
    printf("Pixel at (%d, %d) changed its value from %x to %x.\n", X, Y,
            get_pixel(pixbuf, X, Y), get_pixel(result, X, Y));

    
    gdk_pixbuf_save(result, FILE_TO_SAVE, "ico", NULL, NULL);
    
    g_object_unref(pixbuf);
    g_object_unref(result);

    return 0;
}
